% link_light()
%    Reset light to camera position after each rotation
%
function link_light()

    h = rotate3d;
    h.ActionPostCallback = @rotatecallback;
    h.Enable = 'on';
    
    rotatecallback([],[])
end

function rotatecallback(obj,evt)
    h = findobj(gca,'type','light');
    for iter = 1:numel(h)
        ax = ancestor(h(iter), 'axes');
        pos  = get(ax, 'cameraposition' );
        targ = get(ax, 'cameratarget'   );
        dar  = get(ax, 'dataaspectratio');
        up   = get(ax, 'cameraupvector' );

        [newPos, newUp] = camrotate(pos,targ,dar,up,30,30,'camera',[]);

        set(h(iter), 'position', newPos);
    end
end