% link_subplots(h)
%    All provided subplots will be linked together (rotation/manipulation)
%      h - handles of subplots
%
function link_subplots(handles)

    if nargin<1
        handles = findobj(gcf,'type','axes','tag','');
    end

    data.linkcam = linkprop(handles,{'CameraPosition','CameraUpVector','CameraTarget','CameraViewAngle','CameraViewAngleMode','DataAspectRatio','PlotBoxAspectRatio'});

    % Link lighting if any
    hl = [];
    for i = 1:numel(handles)
        hl = [hl findobj(handles(i),'type','light')];
    end

    if ~isempty(hl);  data.linklight = linkprop(hl,{'position'});  end;
    
    set(gcf,'UserData',data);
end
