% mytic
%   Start timer
%     string - timer name (default: '')
%              if string is 'reset', or 1: resets global tictoc counter
%
% herve.lombaert@gmail.com, May 2016
%
function mytic(string)

    do_reset = 0;
    if nargin<1;  string = '';  end;
    if strcmp(string,'reset') | (string == 1);  do_reset = 1;  end;
    
    is_multithreading = ( exist('gcp','file') && ~isempty(gcp('nocreate')) ) || ( ~exist('gcp','file') && exist('matlabpool','file') && (matlabpool('size')>0) );
    
    if ~is_multithreading
        
        global gtictoc_cnt gtictoc_times gtictoc_last_strings;

        if do_reset;  gtictoc_cnt = [];  gtictoc_times = [];  gtictoc_last_strings = [];  return;  end;

        % Increase tictoc counter
        if isempty(gtictoc_cnt);  gtictoc_cnt = 0;  end;
        gtictoc_cnt = gtictoc_cnt + 1;
        gtictoc_last_strings{gtictoc_cnt} = string;

        % Here: tic;
        gtictoc_times(gtictoc_cnt,:) = clock; %cputime;
    
    else
        
        % Do not overwrite global variable, instead create new ones that
        % has their scope within each parfor only
        
        global g_mt_tictoc_cnt g_mt_tictoc_times g_mt_tictoc_last_strings;

        if do_reset;  g_mt_tictoc_cnt = [];  g_mt_tictoc_times = [];   g_mt_tictoc_last_strings = [];  return;  end;

        % Increase tictoc counter
        if isempty(g_mt_tictoc_cnt);  g_mt_tictoc_cnt = 0;  end;
        g_mt_tictoc_cnt = g_mt_tictoc_cnt + 1;
        g_mt_tictoc_last_strings{g_mt_tictoc_cnt} = string;

        % Here: tic;
        g_mt_tictoc_times(g_mt_tictoc_cnt,:) = clock; %cputime;
        
    end
end
