%% runme.m
%% Herve Lombaert, Jan 30, 2018
%%
%% Testing spectral matching

clear all;

% Paths
addpath(['lib'])
addpath(['lib/freesurfer'])

% pathname = '/Users/hlombaer/Downloads/Herve';
% pathname = 'brain-meshes-matlab';
pathname = 'data';


if do_display;  clf;  set(gcf,'color','w'); colormap jet;  end

%% Reading meshes
% id1 = '017L';
% id2 = '019L';
id1 = 'OASIS-TRT-20-1';
id2 = 'OASIS-TRT-20-2';

[M1, M2, corr] = load_meshes(pathname, id1, id2);

%% Spectral Aligner
[corr, M1, M2] = spectralign(M1, M2);

%% Display Transfered Map
subplot(211); displaymesh(M1.X, M1.F, M1.S);               title('Mesh 1 + Map 1');
subplot(212); displaymesh(M2.X, M2.F, M1.S(corr.corr21));  title('Mesh 2 + Transfered Map 1');
link_subplots

%% Smooth meshes a bit for visualization
M1.Xs = M1.X;  l = M1.E.Dinv*M1.E.W;  for i=1:50;  M1.Xs = l * M1.Xs;  end;
M2.Xs = M2.X;  l = M2.E.Dinv*M2.E.W;  for i=1:50;  M2.Xs = l * M2.Xs;  end;
%
subplot(211); displaymesh(M1.Xs, M1.F, M1.P);               title('Mesh 1 + Map 1');
subplot(212); displaymesh(M2.Xs, M2.F, M1.P(corr.corr21));  title('Mesh 2 + Transfered Map 1');
link_subplots
colormap jet;

disp('Done.');